package com.zcxk.service;

import com.baomidou.mybatisplus.core.metadata.IPage;

import com.zcxk.dto.UserAuthDto;
import com.zcxk.entity.User;

import java.util.List;

/**
 * 用户(User)表服务接口
 *
 * @author makejava
 * @since 2020-10-21 15:23:49
 */
public interface UserService {

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    User selectById(Integer id);


    /**
     * 查询全部
     *
     * @return 对象列表
     */
    List<User> selectAll();

    /**
     * 通过实体作为筛选条件查询
     *
     * @param user 实例对象
     * @return 对象列表
     */
    List<User> selectList(User user);

    /**
     * 新增数据
     *
     * @param user 实例对象
     * @return 影响行数
     */
    int insert(User user);

    /**
     * 批量新增
     *
     * @param users 实例对象的集合
     * @return 影响行数
     */
    int batchInsert(List<User> users);

    /**
     * 修改数据
     *
     * @param user 实例对象
     * @return 修改
     */
    int update(User user);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 影响行数
     */
    int deleteById(Integer id);

    /**
     * 查询总数据数
     *
     * @return 数据总数
     */
    int count();

    IPage<User> selectPage(User user, IPage<User> page);
    User findUser(User user);

    User chooseUser(User user);
    boolean logOut(String token);

    /**
     * 新增注册数据
     * @author yjy
     * @param user 实例对象
     * @return 影响行数
     */
    int insertRegister(User user);
     void offline(String clientId, Integer userId, Integer status);

    String getRangeCode(String appId);


    String getUniqId(String appId, String appSecret, String code);

    /**
     * 获取用户标识，通过AES解密得到的key获取
     * @param appId          appid
     * @param encryptValue   AES加密值
     * @return
     */
    UserAuthDto getUniqId(String appId, String encryptValue);

}